﻿using System;
using UIKit;
using Photos;
using Foundation;

namespace VJ
{
	public partial class ViewController : UIViewController
	{
		MyImageView _imageView;
		MySound _sound = new MySound();
		const long StartTimeSpan = 10000000;
		long _time = StartTimeSpan;
		DateTime  _date;
		double _elapsed = StartTimeSpan;

		protected ViewController(IntPtr handle) : base(handle)
		{
			_imageView = new MyImageView(this);
		}

		public override async void ViewDidLoad()
		{
			base.ViewDidLoad();
			var status = PHPhotoLibrary.AuthorizationStatus;
			if (status != PHAuthorizationStatus.Authorized)
			{
				await PHPhotoLibrary.RequestAuthorizationAsync();
			}
			_imageView.ReadImage(View.Bounds);
			RepeatSound();
	 		Add(_imageView);
		}

		public override void DidReceiveMemoryWarning()
		{
			base.DidReceiveMemoryWarning();
		}

		void RepeatSound()
		{
			_date = DateTime.Now;
			_imageView.RandomImage();
			NSTimer.CreateScheduledTimer(new TimeSpan(_time), (obj) =>
			{
				_sound.PlaySound(0);
				if (_time <= 3000000)
				{
					PerformSegue("_gameClear", this);
					return;
				}
				else if (_elapsed < (double)_time*0.0003)
				{
					_time -= (long)(StartTimeSpan*0.025);
				}
				else
				{
					_time = StartTimeSpan;
				}
				_elapsed = StartTimeSpan;
				RepeatSound();
			});
		}

		public void PlaySound()
		{
			_sound.PlaySound(1);
			if (_elapsed >= StartTimeSpan)
			{
				_elapsed = _date.Subtract(DateTime.Now).TotalMilliseconds * -1;
			}
			else
			{
				_elapsed = StartTimeSpan;
			}
		}
	}
}
